#define MAGICMA  20110426
extern string Moving =" ";
extern int MovingPeriod1       = 52;
extern int MovingShift1        = 0;
extern int MovingPeriod2       = 144;
extern int MovingShift2        = 0;
extern string Stoch =" ";
extern int KPeriod1 = 14;
extern int StochOversold1      = 10;
extern int StochOverbought1    = 90;
extern int KPeriod2 = 14;
extern int StochOversold2      = 10;
extern int StochOverbought2    = 90;
extern string Trailing_Funcion = "  ";
extern double Lots             = 0.2;
extern double StopLoss         = 0.01;
extern double TakeProfit       = 0.03;
extern bool tral =true;
extern int TrailingStop = 300; //   ,   
extern int TrailingStep = 0; //  

//|     |
void T_SL()
  {
   int i=0;
   for(i=0; i<OrdersTotal(); i++)
     {
      if(!(OrderSelect(i, SELECT_BY_POS, MODE_TRADES)))
         continue;
      if(OrderSymbol() != Symbol())
         continue;
      if(OrderMagicNumber()!=MAGICMA)
         continue;
      if(OrderType()==OP_BUY)
        {
         if(NormalizeDouble(Bid-OrderOpenPrice(),Digits)>NormalizeDouble(TrailingStop*Point,Digits))
           {
            if(NormalizeDouble(OrderStopLoss(),Digits)<NormalizeDouble(Bid-(TrailingStop+TrailingStep-1)*Point,Digits))
              {
               OrderModify(OrderTicket(), OrderOpenPrice(), NormalizeDouble(Bid-TrailingStop*Point,Digits), OrderTakeProfit(), 0, CLR_NONE);
              }
           } //end if(NormalizeDouble(Bid-OrderOpenPrice(),Digits)>NormalizeDouble(TrailingStop*Point,Digits))
        } //end if(OrderType()==OP_BUY)
      if(OrderType()==OP_SELL)
        {
         if(NormalizeDouble(OrderOpenPrice()-Ask,Digits)>NormalizeDouble(TrailingStop*Point,Digits))
           {
            if(OrderStopLoss()==0 || NormalizeDouble(OrderStopLoss(),Digits)>NormalizeDouble(Ask+(TrailingStop+TrailingStep-1)*Point,Digits))
              {
               OrderModify(OrderTicket(), OrderOpenPrice(), NormalizeDouble(Ask+TrailingStop*Point,Digits), OrderTakeProfit(), 0, CLR_NONE);
              }
           }
        }
     }
  }
//|      |

//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)
  {
   int buys=0,sells=0;
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA)
        {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;
        }
     }
//---- return orders volume
   if(buys>10) return(buys);
   else if(sells>10) return(sells);
  }

//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForOpen()
  {
//---- go trading only for first tiks of new bar
   if(Volume[0]>1) return;
//---- get Moving Average   
   int    res;  
//---- 
   double ma10=iMA(NULL,0,MovingPeriod1,MovingShift1,MODE_SMA,PRICE_CLOSE,0); //  Moving  Average   
   double ma11=iMA(NULL,0,MovingPeriod1,MovingShift1,MODE_SMA,PRICE_CLOSE,1); //  Moving  Average   
   double ma12=iMA(NULL,0,MovingPeriod1,MovingShift1,MODE_SMA,PRICE_CLOSE,2); //  Moving  Average   
   double ma20=iMA(NULL,0,MovingPeriod2,MovingShift2,MODE_SMA,PRICE_CLOSE,0); //  Moving  Average   
   double ma21=iMA(NULL,0,MovingPeriod2,MovingShift2,MODE_SMA,PRICE_CLOSE,1); //  Moving  Average   
   double ma22=iMA(NULL,0,MovingPeriod2,MovingShift2,MODE_SMA,PRICE_CLOSE,2); //  Moving  Average   
   double st1=iStochastic(NULL,0,KPeriod1,3,3,MODE_SMA,0,MODE_MAIN,0);
   double st2=iStochastic(NULL,5,KPeriod2,3,3,MODE_SMA,0,MODE_MAIN,0);
//---- buy 
   if(ma11>ma12 && ma10>ma11 && ma21>ma22 && ma20>ma21 && Close[1]>ma10 && st1<StochOversold1 && st2<StochOversold2)  // Moving  Average , Stochastic       Moving  Average
     {
      res=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,Ask-StopLoss,Ask+TakeProfit,"",MAGICMA,0,Blue);
      return;
     }      
//---- sell   
   if(ma11<ma12 && ma10<ma11 && ma21<ma22 && ma20<ma21 && Close[1]<ma10 && st1>StochOverbought1 && st2>StochOverbought2)  // Moving  Average , Stochastic       Moving  Average
     {
      res=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,Bid+StopLoss,Bid-TakeProfit,"",MAGICMA,0,Red);
      return;
     }     
  }  

//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()
  {
   double ma10=iMA(NULL,0,MovingPeriod1,MovingShift1,MODE_SMA,PRICE_CLOSE,0); //  Moving  Average   
   double ma11=iMA(NULL,0,MovingPeriod1,MovingShift1,MODE_SMA,PRICE_CLOSE,1); //  Moving  Average   
   double ma12=iMA(NULL,0,MovingPeriod1,MovingShift1,MODE_SMA,PRICE_CLOSE,2); //  Moving  Average   
   double ma20=iMA(NULL,0,MovingPeriod2,MovingShift2,MODE_SMA,PRICE_CLOSE,0); //  Moving  Average   
   double ma21=iMA(NULL,0,MovingPeriod2,MovingShift2,MODE_SMA,PRICE_CLOSE,1); //  Moving  Average   
   double ma22=iMA(NULL,0,MovingPeriod2,MovingShift2,MODE_SMA,PRICE_CLOSE,2); //  Moving  Average   
//--- go trading only for first tiks of new bar
   if(Volume[0]>1)
      return;
//--- get Moving Average
//---
   for(int i=0; i<OrdersTotal(); i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)
         break;
      if(OrderMagicNumber()!=MAGICMA || OrderSymbol()!=Symbol())
         continue;
      //--- check order type
      if(OrderType()==OP_BUY)
        {
         if(ma11<ma12 && ma10<ma11 && ma21<ma22 && ma20<ma21)
           {
            if(!OrderClose(OrderTicket(),OrderLots(),Bid,3,White))
               Print("OrderClose error ",GetLastError());
           }
         break;
        }
      if(OrderType()==OP_SELL)
        {
         if(ma11>ma12 && ma10>ma11 && ma21>ma22 && ma20>ma21)
           {
            if(!OrderClose(OrderTicket(),OrderLots(),Ask,3,White))
               Print("OrderClose error ",GetLastError());
           }
         break;
        }
     }
//---
  }

//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()
  {
     if(tral)
     {
      T_SL();
     }
//---- check for history and trading
   if(Bars<100 || IsTradeAllowed()==false) return;
//---- calculate open orders by current symbol
   if(CalculateCurrentOrders(Symbol())==0) CheckForOpen();
   else      CheckForClose();
  }
//+------------------------------------------------------------------+
